/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.common;

/**
 * Validation error: presents criticality and message
 *
 * @author ssg
 */
public abstract class ValidationError {

    private CRITICALITY _criticality;
    private Path _path;

    public ValidationError(CRITICALITY criticality) {
        _criticality = (criticality != null) ? criticality : CRITICALITY.error;
    }

    public ValidationError(CRITICALITY criticality, Path path) {
        _criticality = (criticality != null) ? criticality : CRITICALITY.error;
        if(path!=null) {
            _path=new Path(null);
            _path.copyPath(path);
        }
    }

    public abstract String getMessage();

    /**
     * @return the _criticality
     */
    public CRITICALITY getCriticality() {
        return _criticality;
    }

    /**
     * @param criticality the _criticality to set
     */
    public void setCriticality(CRITICALITY criticality) {
        this._criticality = criticality;
    }

    /**
     * @return the _path
     */
    public Path getPath() {
        return _path;
    }

    /**
     * @param path the _path to set
     */
    public void setPath(Path path) {
        Path p = new Path(null);
        p.copyPath(path);
        this._path = p;
    }
}
