/*
 * Copyright 2011 sesidoro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * Classes providing commonly used but not limiting to format or parsing/formatting functionality.
 * Most important classes are:
 * - BufferingReader - provides read/unread interface for base Reader. Used in parser(s).
 * - CommandLineToolPrototype - class to extend when making command line tools (see converter and diff examples).
 * - NonResizableListForArray - list wrapper for any array in Java (including byte[], int[], Object[] etc.).
 * - P and P.PP - reflection-based access for reading and modifying data at certain "path".
 *    Class P implements static methods while P.PP - instance methods and allows overridable behaviour.
 *    Path is represented as variable argument parameter(s).
 *    Class P.PP supports multiple "path" providers: class Path, dot- and slash- delimited strings (like "aaa.bbb[1].ccc").
 * - StructureWriter - used in formatter for contextual writes. May be overriden to keep track of data and text positions.
 * - URIResolverExtended - prevents searching of external resources when processing XML files.
 * - URLResolver - cacheing solution used mainly in JSON schema for loading/substitution of referenced files.
 *     Relies on cached (as resources) version on basic- and hyper- schemas.
 */
package com.ssg.tools.jsonxml.common.tools;
