/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.json;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;

/**
 *
 * @author ssg
 */
public class JSONFormatterLite {

    public static String format(Object data) throws IOException {
        return format(data, false);
    }

    public static String format(Object data, boolean indent) throws IOException {
        StringWriter writer = new StringWriter();
        JSONFormatterLiteContext ctx = new JSONFormatterLiteContext(writer);
        ctx.setIndent(indent);
        JSONFormatterLite.format(ctx, data);
        return writer.toString();
    }

    public static void format(Writer writer, Object data) throws IOException {
        JSONFormatterLiteContext ctx = new JSONFormatterLiteContext(writer);
        JSONFormatterLite.format(ctx, data);
    }

    public static void format(JSONFormatterLiteContext ctx, Object data) throws IOException {
        ctx.writeValue(data);
    }
}
