/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.json.schema;

/**
 *
 * @author ssg
 */
public class JLink extends JSchema {

    public String getHref() throws JSONSchemaException {
        return (String) _attributes.get(ATTRIBUTE._href);
    }

    public void setHref(String value) throws JSONSchemaException {
        set(ATTRIBUTE._href, value);
    }

    public String getRel() {
        return (String) _attributes.get(ATTRIBUTE._rel);
    }

    public void setRel(String value) {
        set(ATTRIBUTE._rel, value);
    }

    public JSchema getTargetSchema() {
        return (JSchema) _attributes.get(ATTRIBUTE._targetSchema);
    }

    public void setTargetSchema(JSchema value) {
        set(ATTRIBUTE._targetSchema, value);
    }

    public METHOD getMethod() {
        METHOD m = (METHOD) _attributes.get(ATTRIBUTE._method);
        return (m != null) ? m : METHOD.GET;
    }

    public void setMethod(METHOD value) {
        set(ATTRIBUTE._method, value);
    }

    public String getEnctype() {
        return (String) _attributes.get(ATTRIBUTE._enctype);
    }

    public void setEnctype(String value) {
        set(ATTRIBUTE._enctype, value);
    }

    public JSchema getSchema() {
        return (JSchema) _attributes.get(ATTRIBUTE._schema);
    }

    public void setSchema(JSchema value) {
        set(ATTRIBUTE._schema, value);
    }

    @Override
    public boolean validate(JSONValidationContext ctx, Object data, boolean recursive) throws JSONSchemaException {
        return super.validate(ctx, data, recursive);
        // TODO: JLink-specific validations...
    }
    
}
