/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.json.schema;

import java.util.Collections;

/**
 * Attribute-level validator.
 */
/**
 *
 * @author ssg
 */
public abstract class JSONAttributeValidator extends JSONDataValidator {

    public abstract ATTRIBUTE getAttribute();

    public abstract boolean validate(JSONValidationContext ctx, Object data, JSchema schema) throws JSONSchemaException;

    @Override
    public boolean validate(JSONValidationContext ctx, Object data, JSchema schema, boolean recursive) throws JSONSchemaException {
        return validate(ctx, data, schema, false);
    }

    public Iterable<ATTRIBUTE> getTestedAttributes() {
        return Collections.singletonList(getAttribute());
    }
}
