/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ssg.tools.jsonxml.json.schema;

import com.ssg.tools.jsonxml.common.CRITICALITY;
import com.ssg.tools.jsonxml.common.ValidationError;
import com.ssg.tools.jsonxml.common.Path;

/**
 *
 * @author ssg
 */
public class JSONValidationError extends ValidationError {
    //boolean _severe = true;

    //Path _path = new Path(null);
    Object _data;
    JSchema _schema;
    ATTRIBUTE _errorAttribute;
    String _description;

    public JSONValidationError(Path path, Object data, JSchema schema, ATTRIBUTE attr, String description) {
        super(CRITICALITY.error, path);
        _data = data;
        _schema = schema;
        _errorAttribute = attr;
        _description = description;
    }

    public JSONValidationError(Path path, Object data, JSchema schema, ATTRIBUTE attr, String description, boolean severe) {
        super((severe) ? CRITICALITY.error : CRITICALITY.warning, path);
        setPath(path);
        _data = data;
        _schema = schema;
        _errorAttribute = attr;
        _description = description;
        //_severe = severe;
    }

    @Override
    public String getMessage() {
        return "[" + getCriticality() + "] " + getPath() + " [" + _errorAttribute + "]: " + _description;
    }
}
