/*
 * Copyright 2011 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *
 * JSONXML is library used to process tree-like object structures in popular text formats: XML and JSON.
 * It may be considered as "alternative" serializer but it is not (though may be adapted).
 * Processors include:
 * - parser : converts STRING into OBJECT
 * - formatter : converts OBJECT itno STRING
 * - comparer : compares 2 OBJECTs
 * - validator : validate STRING and/or OBJECT. 
 *   Supports schema validation of:
 *    * XML (java built-in)
 *    * JSON (JSON schema, http://tools.ietf.org/html/draft-zyp-json-schema-03), limited so far
 *
 * For parsing it accepts "java.io.Reader" and return java object.
 * For formatting it accepts java object and writes text to "java.io.Writer" or returns String.
 *
 * Object is generally a structure that contains Map and/or List elements.
 * Map is ordered set of named items. List is set of unnamed items.
 * Reflection may be used to convert objects into set of maps/lists and vice versa.
 *
 * Instances of objects may be created using BigFactory instance.
 * This factory provides info on supported formats and allows creation of appropriate processor instances (if available).
 * Factory defines commonly used(able):
 * - locale
 * - time zone
 * - reflective builder
 * - URL resolver
 * 
 * Factory provides mechanism of adjusting created objects, e.g assigning to structure processing
 * contexts reflective builder.
 * 
 * See samples in converter and diff.
 */
package com.ssg.tools.jsonxml;
